if(!dojo._hasResource["com.ibm.customize.Menu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.Menu"] = true;
// This is a menu.  It takes a list of sources that each have label attributes to use as display titles.  It publishes an event on a source each time one is clicked.
dojo.provide("com.ibm.customize.Menu");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.fx.easing");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Shelf");


dojo.declare("com.ibm.customize.Menu",
	[dijit._Widget, dijit._Templated],
	{
		sources: [],									// an array of objects containing labels and datastore hubs for each menu choice
		choices: {},									// a map of label : DOMNode pairs for each choice in the menu
		searchId: "",									// the id of the Container to search within
		menuTitle: "Menu",								// title for the menu
		current: null,									// the menu choice currently selected
		blankImg: "",									// path to a clear pixel
		selectedText: "currently selected category",
		unselectedText: "press enter to browse this category",
		publishKeyword: "/epc/customize/changeSource",	// the keyword to publish to add a filter
		templateString: '<div dojoAttachPoint="focusNode">' +
							/*'<h3>' +
								'<a dojoAttachPoint="back" title="back" class="lotusBtnImg lotusHidden" href="javascript:void(0)">' +
									'<img alt="${backText}" src="${blankImg}">' +
									'<span class="lotusAltText">${backText}</span>' +
								'</a>' +
								' ${menuTitle}' +
							'</h3>' +*/
							'<div role="menu" dojoAttachPoint="menuContainer" class="lotusMenu">' +
								'<ul dojoAttachPoint="list"></ul>' +
							'</div>' + 
						'</div>',
		
		constructor: function() {
			this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.menuTitle = this.bundle["shelf_menu"];
			this.selectedText = " " + this.bundle["menu_selected_text"];
			this.unselectedText = " " + this.bundle["menu_unselected_text"];
			//this.backText = this.bundle["menu_back"] || "Back";
		},
	
		postCreate: function(){
			// summary: populates the menu with the given choices
			//this.back.onclick = dojo.hitch(this,function(){this.backOneLevel();return false;});
			this.processSources(this.sources);
		},
		
		processSources: function(sources){
			dojo.empty(this.list);
			if(this.sources.length > 0) {
				// add the choices to the menu with the first choice selected
				dojo.forEach(sources, dojo.hitch(this, function(choice){ this.addLi(choice); }));
				if(!sources[0].categories) this.select(sources[0]);  // select if it's a datastore
				else dojo.publish(this.publishKeyword+this.searchId, [{hub:{searchable:false},label:sources[0].label}]);  // parent category
			}
		},
		
		addLi: function(/*Object*/choice){
			// summary: adds a new element to the list of choices in the menu
			// choice: a member of the choices array to add to the menu
			var li = dojo.create("li",{"role":"menuitem"});
			if(choice.categories) dojo.addClass(li,"lotusMore");
			var evtHandlers = this._createLiEventHandlers(choice);
			var newLink = dojo.create("a",{href:"javascript:void(0)",innerHTML:choice.label});
			newLink.onclick = evtHandlers.anchorOnclick;
			li.appendChild(newLink);
			var selectedSpan = dojo.create("span",{innerHTML:this.unselectedText,className:"",className:"ibmPortalHiddenText ibmHiddenText wpthemeAccess"});
			newLink.appendChild(selectedSpan);
			// when the menu item is clicked, call the select function on it
			dojo.connect(li, 'onclick', evtHandlers.liOnclick);
			// add the new item to DOM and the map of choices
			this.list.appendChild(li);
			this.choices[choice.url] = {li:li,span:selectedSpan};
		},
		
		_createLiEventHandlers: function (choice) {
			return {
				anchorOnclick: function(){ return false; /* to prevent onBeforeUnload event from triggering in IE */ },
				liOnclick: dojo.hitch( this, function(){ this.select(choice); })
			};
		},
		
		select: function(/*Object*/source){
			// summary: triggered by a menu click,
			// source: the menu choice that was clicked
			if(source.categories){
				this.processSources(source.categories);  // drill down
				//dojo.removeClass(this.back,"lotusHidden");  // show back button
			} else {
				// publish the event to a specific id so not all instances of the receiving class respond
				dojo.publish(this.publishKeyword+this.searchId, [source]);  // search
				this.changeHighlighting(source);
			}
		},
		
		backOneLevel: function(){
			// summary: drills back up one level
			this.processSources(this.sources);
			//dojo.addClass(this.back,"lotusHidden");
		},
		
		changeHighlighting: function(/*String*/source){
			// summary: switches which menu choice is selected
			// source: the menu choice that was chosen
			if(source.categories) return;  // parent categories are never highlighted
			if(this.current) {
				dojo.removeClass(this.choices[this.current].li, "lotusSelected");
				this.choices[this.current].span.innerHTML = this.unselectedText;
			}
			dojo.addClass(this.choices[source.url].li, "lotusSelected");
			this.choices[source.url].span.innerHTML = this.selectedText;
			this.current = source.url;
		}
});

}
