if(!dojo._hasResource["com.ibm.data.CatalogFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.CatalogFeedStore"] = true;
//C:\Documents and Settings\Administrator\workspace\enabler\lwp\enabler\eclipse\plugins\com.ibm.mm.enabler\resources\js\com\ibm\mm\enabler\model\catalog.js
//for category entry API line 923
dojo.provide("com.ibm.data.CatalogFeedStore");
dojo.require("com.ibm.data.CatalogMixin");
dojo.declare("com.ibm.data.CatalogFeedStore", 
		[com.ibm.data.CatalogMixin],
		{
			searchable: false,
			items: [],
			attributes: ["id","label","description","thumbnail","definition"],
			features: {'dojo.data.api.Read': true},
			label: "",
			category: "",
			pageSize: 30,
			//defaultCatalog: "default",
			valid: true,
		       
			constructor: function(args) {
				this.items = [];
				this.category = args.category;
				var catalogModel = com.ibm.mashups.enabler.model.Factory.getCatalogCategoryModel();
				catalogModel.setStrategy(new com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy(this.pageSize));
				/*var catalogStr = args.catalog || this.defaultCatalog;
				var categoryStr = ibmPortalConfig ? this.category : this.category + "_c_" + catalogStr;
				var category = catalogModel.find(categoryStr).start();*/
				var category = catalogModel.find(this.category).start();
				if(!category){
					this.valid = false;
					return;
				}
				var locale = com.ibm.mashups.enabler.context.Factory.getLocalizedContext().getLocale() || "en"; // RETURNS NULL
				this.label = category.getTitle(locale);
				var entryIter = catalogModel.getCatalogEntryModel(category).iterator();
				while (entryIter.hasNext()){
					var entry = entryIter.next();
					this.items.push({
						"id":entry.getID(),
						"label":entry.getTitle(locale),
						"description":entry.getDescription(locale),
						"thumbnail":entry.getIconURL(),
						"url":entry.getDefinitionURL()
					});
				}
			},
			
			getValue: function(/* item */ item, /* attribute-name-string */ attribute, /* value? */ defaultValue){
				return item[attribute] || defaultValue;
			},
			
			getValues: function(/* item */ item, /* attribute-name-string */ attribute){
				var value = this.getValue(item,attribute,null);
				return value ? [value] : [];
			},
			
			getAttributes: function(/* item */ item){
				return this.isItem(item) ? this.attributes : [];
			},
			
			hasAttribute: function(/* item */ item, /* attribute-name-string */ attribute){
				return item[attribute] ? true : false;
			},
			
			containsValue: function(/* item */ item, /* attribute-name-string */ attribute, /* anything */ value){
				var values = this.getValues(item,attribute);
				for(var i in values){
					if(values[i] == value) return true
				}
				return false;
			},
			
			isItem: function(/* anything */ something){
				for(var i in this.items){
					if(this.items[i].id == something.id) return true;
				}
				return false;
			},
			
			isItemLoaded: function(/* anything */ something){
				return this.isItem(something);
			},
			
			loadItem: function(/* object */ keywordArgs){
				// do nothing because all items are already loaded
			},
			
			fetch: function(/* Object */ keywordArgs){
				try {
					var scope = keywordArgs.scope || dojo.global,
						items = [],
						count = keywordArgs.count,
						start = keywordArgs.start;
					if(!start) start = 0;
					if(keywordArgs.onBegin) keywordArgs.onBegin.call(scope,this.items.length,keywordArgs);
					if(start < this.items.length){
						if(count && count + start <= this.items.length){
							items = this.items.slice(start,count);
						} else {
							items = this.items.slice(start);
						}
					}
					if(keywordArgs.onItem){
						dojo.forEach(items,function(item){keywordArgs.onItem.call(scope,item,keywordArgs)});
					}
					var itemsLeft = keywordArgs.onItem ? null : items;
					if(keywordArgs.onComplete) keywordArgs.onComplete.call(scope,itemsLeft,keywordArgs);
					return dojo.mixin(keywordArgs,{abort:function(){}});
				} catch (e) {
					if(keywordArgs.onError) keywordArgs.onError.call(scope,e,keywordArgs);
				}
			},
			
			getFeatures: function(){
				return this.features;
			},
			
			close: function(/*dojo.data.api.Request || keywordArgs || null */ request){
				// nothing to do here
			},
			
			getLabel: function(/* item */ item){
				if(this.isItem(item)) return item["label"];
				else return null;
			},
			
			getLabelAttributes: function(/* item */ item){
				return ["label"];
			},
			
			getSourceLabel: function(){
				return this.label;
			},
			
			validateSelf: function(){
				// summary: validates this datastore, if it does not validate the source will not be used
				// returns true for validation and false otherwise
				return this.valid;
			}
});

}
