if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.string");

/**
 */
dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.IconsListControl", [dijit._Widget, dijit._Templated], {

    selectedIcon: null,
    
    widgetId: null,
    
    templateString: "<div role='listbox' dojoAttachPoint='iconsList' dojoAttachEvent='onclick:selectIcon' class='iconsListControl'></div>",
    
    altIndexBase: "EDIT_SPACE_ICON_ALT_IMAGE",
    
    iconsNumber: 41,
    
    needRefresh: true,
    
    /**
     * Constructor.
     */
    constructor: function(){
        this._iconIdPrefix = "spaceEditor_icons_";
    },
    
    postMixInProperties: function(){
        this.bundle = com.ibm.mm.builder.coreWidgetsStrings;
        dojo.mixin(this, this.bundle);
    },
    
    refresh: function(){
        if (this.needRefresh === true) {
            dojo.empty(this.iconsList);
            var iconNodeAlt = this.bundle.EDIT_SPACE_ICON_ALT;
            
            for (var i = 1; i <= this.iconsNumber; i++) {
            
                var id = i < 10 ? ("0" + i) : i;
                var iconNodeId = this._iconIdPrefix + id;
                
                var iconLink = dojo.create("a", {
                    id: iconNodeId,
                    href: "#",
                    role: "option"
                }, this.iconsList, "append");
                dojo.addClass(iconLink, "icon");
                this.connect(iconLink, "onkeypress", this.selectIconByKey);
                this.connect(iconLink, "onclick", this.selectIcon);
                
                var alt = this.bundle[this.altIndexBase + i] || dojo.string.substitute(iconNodeAlt, [id]);
                dojo.create("img", {
                    src: builderConfig.builderPath + "/images/spaceicons/icon-" + id + ".gif",
                    alt: alt
                }, iconLink, "only");
                
                if (i == 1) {
                    dojo.addClass(iconLink, "space_icon_selected");
                    this.selectedIcon = iconLink;
                }
            }
            this.needRefresh = false;
        }
    },
    
    getSelectedIconId: function(){
        return dojo.attr(this.selectedIcon, "id").substring(this._iconIdPrefix.length);
    },
    
    setSelectedIcon: function(iconId){
        var node = dojo.byId(this._iconIdPrefix + iconId);
        if (node) {
            this._makeIconSelected(node);
        }
    },
    
    _makeIconSelected: function(newSelected){
        if (this.selectedIcon) {
            dojo.removeClass(this.selectedIcon, "space_icon_selected");
            
            dojo.forEach(dojo.query(".access", this.selectedIcon), dojo.hitch(this, function(item){
                this.selectedIcon.removeChild(item);
            }));
            
        }
        dojo.addClass(newSelected, "space_icon_selected");
        this.selectedIcon = newSelected;
        
        var isSelected = dojo.doc.createElement("span");
        dojo.addClass(isSelected, "access");
        isSelected.appendChild(dojo.doc.createTextNode(this.bundle.I_MODE_IS_SELECT));
        newSelected.appendChild(isSelected);
    },
    
    selectIcon: function(evt){
        var clicked = evt.target;
        if (!dojo.hasClass(clicked, "icon") && clicked.tagName != "IMG") {
            return;
        }
        
        var iconNode = dojo.hasClass(clicked, "icon") ? clicked : clicked.parentNode;
        if (this.selectedIcon == iconNode) {
            return;
        }
        this._makeIconSelected(iconNode);
    },
    
    selectIconByKey: function(evt){
    
        if (evt.keyCode != dojo.keys.ENTER && evt.charCode != dojo.keys.SPACE) {
            return;
        }
        
        var iconDiv = evt.target;
        
        this.setSelectedIcon(iconDiv.id.substring(this._iconIdPrefix.length));
        
    }
    
});

}
