if(!dojo._hasResource["com.ibm.widgets.TimedMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.TimedMenu"] = true;
dojo.provide("com.ibm.widgets.TimedMenu");

dojo.declare("com.ibm.widgets.TimedMenu",
			null,
			{
				_onHover: function() {
					this._enter();
				},
				_onUnhover: function() {
					this._exit();
				},
				_onNodeFocus: function(evt){
					this._enter();
					this.inherited(arguments);
				},
				_onNodeBlur: function(evt){
					this._exit();
					this.inherited(arguments);
				},
				_exit: function() {
					this._startCloseTimer();
					if(this.parentMenu && this.parentMenu._startCloseTimer) {
						// if we have a parent that has this function (ie, an instance of the same class),
						// tell it to start its timer too
						this.parentMenu._startCloseTimer();
					}
				},
				_enter: function() {
					this._stopCloseTimer();
				},
				_startCloseTimer: function() {
					// summary: Starts the timer to close this menu if it's not already set.
					//		Marks this menu to be closed and marks the parent menu to be closed too.
					if(!this._closeTimer) {
						this._isClosing = true;
						if(this.parentMenu) this.parentMenu._isClosing = true;
						if(this.closeDelay == 0) {
							this.close();
						} 
						else {
							this._closeTimer = setTimeout(dojo.hitch(this, function(){
								this._closeTimer = null;
								this.close();
							}), this.closeDelay);
						}
					}
				},
				_stopCloseTimer: function() {
					// summary: Stops the timer that closes this menu if it's set.
					//		Clears this menu from being closed and stops the parent
					//		from being closed if it exists.
					this._isClosing = false;
					if(this.parentMenu && this.parentMenu._stopCloseTimer) this.parentMenu._stopCloseTimer();
					if(this._closeTimer) {
						clearTimeout(this._closeTimer);
						this._closeTimer = null;
					}
				},
				canClose: function() {
					// summary: Indicates whether or not this menu can close right now.  Is
					//		used to keep menus from closing when they are editing or in other
					//		conditions.
					return true;
				},
				close: function() {
					// summary: Closes this menu upon the condition that the menu is still set for
					//		close when this is called (typically after some delay).  Will also
					//		call the parent's close function if it exists.
					if(this._isClosing && this.canClose())	{
						var parentMenu = this.parentMenu;
						this.closeAction();
						if(parentMenu && parentMenu.close) parentMenu.close();
					}
				},
				closeAction: function() {
					// summary: Closes this menu.  Can be overriden to animate the close operation or
					//		do something different.  Default is simply to close the menu.  Is called
					//		after delays have already been processed, so take care not to wait for
					//		the expected delay again unless that is the desired action.
					dijit.popup.close(this);
				}
			}
);

}
