/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.runtime.skin.RuntimeSkinModel" );

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.ListModel");
dojo.require("com.ibm.mashups.enabler.runtime.skin.ModifiableRuntimeSkinNode");
dojo.require("com.ibm.mashups.enabler.runtime.skin.RuntimeSkinLocator");
dojo.require("com.ibm.mashups.enabler.runtime.skin.StyleFilter");
dojo.require("com.ibm.mashups.enabler.runtime.skin.StyleFilterChain");
//dojo..require("com.ibm.mashups.enabler.layout.LayoutNode");
dojo.require("com.ibm.mashups.enabler.Invalidatable");

/**
 * Interface for a runtime skin model.<br><br>
 * <i>Note: Using Strategies is not supported</i>
 *
 * @since 2.4
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare( "com.ibm.mashups.enabler.runtime.skin.RuntimeSkinModel", 
[com.ibm.mashups.enabler.ListModel, com.ibm.mashups.enabler.runtime.skin.RuntimeSkinLocator, com.ibm.mashups.enabler.Invalidatable], {
    
    /**
     * Adds a Style Filter to this runtime skin model
     * @param {Integer} ordinal postion to add the filter.  Possible values are 0 - 50000.  greater than or equal to 0 will place the filter at the beginning of the chain,
     *                          while greater than or equal to 50000 will add it to the end of the chain.  If a registered filter already has the same ordinal, then the filter to be added
     *                          will be inserted directly after the registered filter with the same ordinal.  See &nbsp; {@link com.ibm.mashups.enabler.runtime.skin.Constants Constants} 
     *                          for ordinal constants for the first and last positions.
     * @param {com.ibm.mashups.enabler.runtime.skin.StyleFilter} filter filter object, must not be <code>null</code>
     * @param {com.ibm.mashups.enabler.layout.LayoutNode} scopeObject LayoutNode object used to scope the RuntimeSkinNodes that a filter
     *        will operate on.  If <code>null</code>, then the filter will operate on all RuntimeSkinNode Style changes.  If
     *        it is an instance of &nbsp; {@link com.ibm.mashups.enabler.layout.LayoutControl LayoutControl}, then the listener will only
     *        operate on RuntimeSkinNode Style changes for the specified LayoutControl.  If it is an instance of 
     *        &nbsp; {@link com.ibm.mashups.enabler.layout.LayoutContainer LayoutContainer},
     *        then the filter will operate on any RuntimeSkinNodes that represent the LayoutContainer's child LayoutControls.
     * @return{Integer} return filter id if the filter is registered successfully, <code>null</code> otherwise
     */
    addStyleFilter: function(ordinal, filter, scopeObject) {
    },
    
    /**
     * Removes a Style filter for this runtime skin model.
     * @param {String} filterId ID of the filter to be removed, must not be <code>null</code>
     * @type void
     */
    removeStyleFilter:function(filterId){
    },
	
	/**
     * Returns the runtime skin for the specified layout node ID
     * @param {String} id the  ID of the LayoutNode object used to find the RuntimeSkinNode. Must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.runtime.skin.ModifiableRuntimeSkinNode} runtime skin node for this LayoutNode, or <code>null</code> if LayoutNode does not exist.
     *         Will also return <code>null</code> if the specified Layout Node is not active (ie, not on the current page)
     * @see com.ibm.mashups.enabler.runtime.skin.ModifiableRuntimeSkinNode
     */
	find: function (id) {
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.runtime.skin.RuntimeSkinModelImpl");
