/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.user.Entity");

dojo.require("com.ibm.mashups.enabler.Identifiable");
dojo.require("com.ibm.mashups.enabler.user.VirtualType");
//<INTERFACE>
/**
 * Interface representing an entity which acts as a base class for a user or a group
 * @ibm-api
 * @ibm-module UserModel
 */
dojo.declare("com.ibm.mashups.enabler.user.Entity", [com.ibm.mashups.enabler.Identifiable], {
    /**
     * Returns a useful display name. Currently CN + SN for users and CN for groups
     * @return {String} the display name; may be <code>null</code>.
     */
    getDisplayName: function(){
    },
    
    /**
     * Returns the value of user LDAP CN attribute
     * @return {String} the value of the CN attritibute; may be <code>null</code>.
     */
    getCN: function(){
    },
    
    /**
     * Returns the value of the given  attribute name
     * @param {String} name the attribute name to look up
     * @return {String} the value of the given attribute name; may be <code>null</code>.
     */
    getAttribute: function(name){
    },
    
    /**
     * Returns the read only attribute names as string array.
     * @return {String[]} all attributes names as string array; never  <code>null</code>.
     */
    getReadOnlyAttributeNames: function(){
    },
    
    /**
     * Returns the readable and writable attribute names as string array.
     * @return {String[]} all attributes names as string array; never  <code>null</code>.
     */
    getReadWriteAttributeNames: function(){
    },
    
    /**
     * Returns all the attribute names as string array.
     * @return {String[]} all attributes names as string array; never  <code>null</code>.
     */
    getAttributeNames: function(){
    },
    
    /**
     * Returns if this Entity is virtual.
     * @return {Boolean} if this Entity is virtual
     */
    isVirtual: function(){
    },
    
    /**
     * Returns the type of virtual entity, or null if the entity is not virtual
     * @return {com.ibm.mashups.enabler.user.VirtualType} the virtual type of the entity. May be <code>null</code>.
     */
    getVirtualType: function(){
    },

    /**
     * Returns the type of entity. Maybe 'user" or 'group'
     * @return {String} the type. Must not be <code>null</code>.
     */
    getEntityType: function(){
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.user.EntityImpl");
