/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.wire.WireModel");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.Identifiable");
dojo.require("com.ibm.mashups.enabler.ListModelController");
dojo.require("com.ibm.mashups.enabler.wire.Wire");
dojo.require("com.ibm.mashups.enabler.DirtyFlagProvider");

/**
 * This list model controller exposes wires, which are available with the
 * provider of the wire model. It allows to add and remove wires.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WireModel
 */
dojo.declare("com.ibm.mashups.enabler.wire.WireModel", [com.ibm.mashups.enabler.ListModelController, com.ibm.mashups.enabler.DirtyFlagProvider], {
    /**
     * Creates a wire. Note that the wire will not appear in the model unless
     * it is inserted using the <code>insert</code> method.
     *
     * @param {JSON} context array of predefined information used for the creation of
     * the wire. Must not be <code>null</code>. You must specify all of following:<br>
     * &nbsp;&nbsp;<b><code>sourceWidgetId</code></b> - com.ibm.mashups.enabler.Identifiable of source widget window; mandatory <br>
     * &nbsp;&nbsp;<b><code>sourcePageId</code></b> - com.ibm.mashups.enabler.Identifiable of source page; mandatory <br>
     * &nbsp;&nbsp;<b><code>sourceEventId</code></b> - com.ibm.mashups.enabler.Identifiable of source event; mandatory <br>
     * &nbsp;&nbsp;<b><code>targetWidgetId</code></b> - com.ibm.mashups.enabler.Identifiable of target widget window; mandatory <br>
     * &nbsp;&nbsp;<b><code>targetPageId</code></b> - com.ibm.mashups.enabler.Identifiable of target page; mandatory <br>
     * &nbsp;&nbsp;<b><code>targetEventId</code></b> - com.ibm.mashups.enabler.Identifiable of target event; mandatory <br>
	      * @return {com.ibm.mashups.enabler.wire.Wire} the created wire, or <code>null</code> in case the wire cannot be created.
     * @see com.ibm.mashups.enabler.widget.WidgetWindow
     */
    create: function(context){
    },
	
    /**
     * Returns an array of Wires with the given target widget id.
     * @param {com.ibm.mashups.enabler.Identifiable} id identifiable or string id of the target widget;
     * must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is
     * an array of {com.ibm.mashups.enabler.wire.Wire} objects with the given target widget id.  Never null, but
     * may be empty.
     */
	findByTargetWidget: function(id) {
	},
	
    /**
     * Returns an array of Wires with the given source widget id.
     * @param {com.ibm.mashups.enabler.Identifiable} id identifiable or string id of the source widget;
     * must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is
     * an array of {com.ibm.mashups.enabler.wire.Wire} objects with the given source widget id.  Never null, but
     * may be empty.
     */
	findBySourceWidget: function(id) {
	}
});
//</INTERFACE>

/**
 * @private
 */
com.ibm.mashups.enabler.wire.WireModel.TOPIC_BASE = "/"+("com.ibm.mashups.enabler.wire.WireModel".replace(/\./ig,'/'))+"/";
/**
 * @private
 */
com.ibm.mashups.enabler.wire.WireModel.TOPIC_WIRE_ADDED    = com.ibm.mashups.enabler.wire.WireModel.TOPIC_BASE + "add";
/**
 * @private
 */
com.ibm.mashups.enabler.wire.WireModel.TOPIC_WIRE_REMOVED = com.ibm.mashups.enabler.wire.WireModel.TOPIC_BASE + "remove";

dojo.require("com.ibm.mm.enabler.wire.WireModelImpl");

