/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.xml.XPath");

//<INTERFACE>
/**
 * Interface provides functions to select nodes by evaluating XPATH expression
 * 
 * @ibm-api
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.xml.XPath", null, {
	/**
	 * This interface returns a list of XMLNodes upon XPATH evaluation.
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {XMLNodeList} select nodes from XML document with xpath; may be <code>null</code>.
	 */
	evaluateXPath : function(xpathExpr, doc, namespaces) {
	},
    
    
    /**
	 * This interface returns a single Entry upon XPATH evaluation or null if the entry is not present.
	 * 
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {Object}
     */
    evaluateEntry: function(xpathExpr, doc, namespaces) {
    },
    
    /**
	 * This interface returns a boolean upon XPATH evaluation. Returns false if the result is not valid (e.g. node does not exist, etc.).
	 * 
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {Boolean}
     */
    evaluateBoolean: function(xpathExpr, doc, namespaces) {
    },
    
    /**
	 * This interface returns a String upon XPATH evaluation. Returns an empty String if the result is not valid (e.g. node does not exist, etc.).
	 * If you want to check for existence of an attribute/element use either evaluateBoolean (which returns false if the element is not present) or evaluateEntry (which returns null if the element is not present). 
	 * 
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {String}
     */
    evaluateString: function(xpathExpr, doc, namespaces) {
    },
    
    /**
	 * This interface returns a Number upon XPATH evaluation. Returns zero (0) if the result is not valid (e.g. node does not exist, etc.).
	 * If you want to check for existence of an attribute/element use either evaluateBoolean (which returns false if the element is not present) or evaluateEntry (which returns null if the element is not present). 
	 * 
	 * @param {String} xpathExpr the xpath expression (i.e. /atom:content). Must not be NULL.
	 * @param {XMLDocument} doc the XML document. Must not be NULL.
	 * @param {JSON} namespaces the namespaces used as part of the xpath expression. The json must be of the format {"prefix": "URL", ... }; must not be NULL.<br>
	 * Example: { "atom" : "http://www.w3.org/2005/Atom", "app" : "http://www.w3.org/2007/app" };
	 * 
	 * @return {Number}
     */
    evaluateNumber: function(xpathExpr, doc, namespaces) {
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.xml.XPathImpl");
