/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mm.widget.dataViewer._WB_VER_.v210.widget.ColorPickerButton");

dojo.require("com.ibm.mm.widget.dataViewer._WB_VER_.v210.widget.ColorPalette");
dojo.require("dijit.form.Button");
dojo.require("dijit.form._FormWidget");

dojo.declare("com.ibm.mm.widget.dataViewer._WB_VER_.v210.widget.ColorPickerButton", 
    dijit.form._FormWidget,
    {
    
    templateString: dojo.cache("com.ibm.mm.widget.dataViewer._WB_VER_.v210.widget" , "templates/ColorPickerButton.html"),
    
    widgetsInTemplate: false,
    
    showArrow: true,
    
    type: "button",
    
    value: "#000000",
	
    baseClass: "mumColorPicker",
    
    disabled:false,
    
    colorPickerEnabled:false,
    tabIndex: "-1",//only the inner button need to be tabed
    
    attributeMap: dojo.delegate(dijit.form._FormWidget.prototype.attributeMap, {
		value: this.value
	}),
	
    postCreate: function() {
        this.inherited(arguments);
        if(!dojo.isIE)this._enableColorPicker();//ie has performance issue to parse color picker at start up
        if(this.colorPickerEnabled){
            dojo.style(this.dropDownBtn.iconNode, "backgroundColor", this.value || "#000000");
        }else {
            dojo.style(this.staticColorIcon, "backgroundColor", this.value || "#000000");
        }
         
		var title = dojo.string.substitute(com.ibm.mm.widget.dataViewer._WB_VER_.v210.dataViewerMessages.L_COLOR_PICKER_COLOR_TITLE, [0, 0, 0]);
        dojo.attr(this.domNode, "title", title);
        if (this.colorPickerEnabled) {
            dojo.attr(this.dropDownBtn.titleNode, "title", title);
        }
    },
    
    _changeValue: function(value) {
        this.attr("value", value);
    },
    
    _setValueAttr: function(/*String*/ value,/*Boolean*/ reset){
        if (this.value !== value||reset) {
            this.value = value;
            if(this.colorPickerEnabled)
                dojo.style(this.dropDownBtn.iconNode, "backgroundColor", this.value || "#000000");
            else 
                dojo.style(this.staticColorIcon, "backgroundColor", this.value || "#000000");
            
            var red = parseInt("0x" + value.substr(1, 2), 16),
                green = parseInt("0x" + value.substr(3, 2), 16),
                blue = parseInt("0x" + value.substr(5, 2), 16),
				title = dojo.string.substitute(com.ibm.mm.widget.dataViewer._WB_VER_.v210.dataViewerMessages.L_COLOR_PICKER_COLOR_TITLE, [red, green, blue])
            dojo.attr(this.domNode, "title", title);
            if(this.colorPickerEnabled)
    			dojo.attr(this.dropDownBtn.titleNode, "title", title);
        }
	},
    
    _setShowArrowAttr: function(showArrow) {
        if(!this.colorPickerEnabled) return;
        var arrowNodes = dojo.query(".dijitArrowButtonInner,.dijitArrowButtonChar", this.dropDownBtn.domNode);
        if (showArrow) {
            arrowNodes.style("display", "");
        } else {
            arrowNodes.style("display", "none");
        }
		dojo.toggleClass(this.domNode, "compact", !showArrow);
    },
	
    _enableColorPicker:function(d){
        if(this.disabled) return;
        dojo.style(this.staticColorIcon, "display", "none");
        dojo.style(this.dropDownBtn, "display", "");
        var dijits =dojo.parser.parse(this.focusNode);
        this.dropDownBtn= dijits[0];
        this.colorPicker = dijits[1];
        this.focusNode = this.dropDownBtn.focusNode;
        this.colorPickerEnabled=true;
        this._setShowArrowAttr(false);
        this._setValueAttr(this.value,true);
        
        this.connect(this.colorPicker,"onChange",this._changeValue);
        dojo.style(this.colorPicker, "display", "");
    },
	_setDisabledAttr: function(disabled) {
		this.inherited(arguments);
        this.disabled=disabled;
        if(this.colorPickerEnabled) this.dropDownBtn.attr("disabled", disabled);
	}
});
